ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.23 by root, Sat Dec 18 13:58:12 2010 UTC vs.
Revision 1.39 by root, Sat Apr 2 11:00:34 2011 UTC

7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10# perl build variables 10# perl build variables
11MAKE=make 11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc 13PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 17
18ARCH="$(uname -m)" 18ARCH="$(uname -m)"
19 19
20case "$ARCH" in 20case "$ARCH" in
29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LDFLAGS=
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 37
37# some configuration options for modules 38# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 39PERL_MM_USE_DEFAULT=1
40PERL_MM_OPT="MAN1PODS= MAN3PODS="
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 41#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 42EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
43export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
41 44
42# which extra modules to install by default from CPAN that are 45# which extra modules to install by default from CPAN that are
43# required by mkbundle 46# required by mkbundle
44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 47STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
45 48
46# which extra modules you might want to install 49# which extra modules you might want to install
47EXTRA_MODULES="" 50EXTRA_MODULES=""
48 51
49# overridable functions 52# overridable functions
50preconfigure() { : ; } 53preconfigure() { : ; }
54patchconfig() { : ; }
51postconfigure() { : ; } 55postconfigure() { : ; }
52postbuild() { : ; } 56postbuild() { : ; }
53postinstall() { : ; } 57postinstall() { : ; }
54 58
55# now source user config, if any 59# now source user config, if any
62fi 66fi
63 67
64############################################################################# 68#############################################################################
65# support 69# support
66 70
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 71PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69 72
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 73unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
74unset PERL_MB_OPT
71export LC_ALL=C # just to be on the safe side 75LC_ALL=C; export LC_ALL # just to be on the safe side
76
77# prepend PATH - not required by staticperl itself, but might make
78# life easier when working in e.g. "staticperl cpan / look"
79PATH="$PERL_PREFIX/perl/bin:$PATH"
72 80
73# set version in a way that Makefile.PL can extract 81# set version in a way that Makefile.PL can extract
74VERSION=VERSION; eval \ 82VERSION=VERSION; eval \
75$VERSION=0.912 83$VERSION="1.21"
76 84
77BZ2=bz2 85BZ2=bz2
78BZIP2=bzip2 86BZIP2=bzip2
79 87
80fatal() { 88fatal() {
151perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 159perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
152trying $URL 160trying $URL
153EOF 161EOF
154 162
155 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 163 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
164 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
156 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 165 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
157 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
158 || fatal "$URL: unable to download" 166 || fatal "$URL: unable to download"
159 rm -f perl-$PERL_VERSION.tar.$BZ2 167 rm -f perl-$PERL_VERSION.tar.$BZ2
160 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 168 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
161 fi 169 fi
162 170
164unpacking perl 172unpacking perl
165EOF 173EOF
166 174
167 mkdir -p unpack 175 mkdir -p unpack
168 rm -rf unpack/perl-$PERL_VERSION 176 rm -rf unpack/perl-$PERL_VERSION
169 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 177 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | ( cd unpack && tar xf - ) \
170 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 178 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
171 chmod -R u+w unpack/perl-$PERL_VERSION 179 chmod -R u+w unpack/perl-$PERL_VERSION
172 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 180 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
173 rmdir -p unpack 181 rmdir -p unpack
174 fi 182 fi
175} 183}
226 234
227 # I hate them for this 235 # I hate them for this
228 grep -q -- -fstack-protector Configure && \ 236 grep -q -- -fstack-protector Configure && \
229 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 237 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
230 238
231 preconfigure 239 # what did that bloke think
240 grep -q -- usedl=.define hints/darwin.sh && \
241 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
242
243 preconfigure || fatal "preconfigure hook failed"
232 244
233# trace configure \ 245# trace configure \
234 sh Configure -Duselargefiles \ 246 sh Configure -Duselargefiles \
235 -Uuse64bitint \ 247 -Uuse64bitint \
236 -Dusemymalloc=n \ 248 -Dusemymalloc=n \
238 -Uusethreads \ 250 -Uusethreads \
239 -Uuseithreads \ 251 -Uuseithreads \
240 -Uusemultiplicity \ 252 -Uusemultiplicity \
241 -Uusesfio \ 253 -Uusesfio \
242 -Uuseshrplib \ 254 -Uuseshrplib \
255 -Uinstallusrbinperl \
243 -A ccflags=" $PERL_CCFLAGS" \ 256 -A ccflags=" $PERL_CCFLAGS" \
244 -Dcc="$PERL_CC" \ 257 -Dcc="$PERL_CC" \
245 -Doptimize="$PERL_OPTIMIZE" \ 258 -Doptimize="$PERL_OPTIMIZE" \
246 -Dldflags="$PERL_LDFLAGS" \ 259 -Dldflags="$PERL_LDFLAGS" \
247 -Dlibs="$PERL_LIBS" \ 260 -Dlibs="$PERL_LIBS" \
267 sedreplace ' 280 sedreplace '
268 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 281 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
269 s/ *-fno-stack-protector */ /g 282 s/ *-fno-stack-protector */ /g
270 ' config.sh 283 ' config.sh
271 284
285 patchconfig || fatal "patchconfig hook failed"
286
272 sh Configure -S || fatal "Configure -S failed" 287 sh Configure -S || fatal "Configure -S failed"
273 288
274 postconfigure || fatal "postconfigure hook failed" 289 postconfigure || fatal "postconfigure hook failed"
275 290
276 touch staticstamp.configure 291 touch staticstamp.configure
292}
293
294write_shellscript() {
295 {
296 echo "#!/bin/sh"
297 echo "STATICPERL=\"$STATICPERL\""
298 echo "PERL_PREFIX=\"$PERL_PREFIX\""
299 echo "MAKE=\"$MAKE\""
300 cat
301 } >"$PERL_PREFIX/bin/$1"
302 chmod 755 "$PERL_PREFIX/bin/$1"
277} 303}
278 304
279build() { 305build() {
280 configure 306 configure
281 307
302EOF 328EOF
303 329
304 ln -sf "perl/bin/" "$STATICPERL/bin" 330 ln -sf "perl/bin/" "$STATICPERL/bin"
305 ln -sf "perl/lib/" "$STATICPERL/lib" 331 ln -sf "perl/lib/" "$STATICPERL/lib"
306 332
333 mkdir "$STATICPERL/patched"
334
307 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 335 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
308 rm -rf "$PERL_PREFIX" # by this rm -rf 336 rm -rf "$PERL_PREFIX" # by this rm -rf
309 337
310 "$MAKE" install || fatal "make install: error while installing" 338 "$MAKE" install || fatal "make install: error while installing"
311 339
312 rcd "$PERL_PREFIX" 340 rcd "$PERL_PREFIX"
313 341
314 # create a "make install" replacement for CPAN 342 # create a "make install" replacement for CPAN
315 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 343 write_shellscript SP-make-install-make <<'EOF'
316"$MAKE" || exit 344#CAT make-install-make.sh
317
318if find blib/arch/auto -type f | grep -q -v .exists; then
319 echo Probably an XS module, rebuilding perl
320 if "$MAKE" perl; then
321 mv perl "$PERL_PREFIX"/bin/perl~ \
322 && rm -f "$PERL_PREFIX"/bin/perl \
323 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
324 "$MAKE" -f Makefile.aperl map_clean
325 else
326 "$MAKE" -f Makefile.aperl map_clean
327 exit 1
328 fi
329fi
330
331"$MAKE" install UNINST=1
332EOF 345EOF
333 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
334 346
347 # create a "patch modules" helper
348 write_shellscript SP-patch-postinstall <<'EOF'
349#CAT patch-postinstall.sh
350EOF
351
352 "$PERL_PREFIX/bin/SP-patch-postinstall"
353
335 # trick CPAN into avoiding ~/.cpan completely 354 # help to trick CPAN into avoiding ~/.cpan completely
336 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 355 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
337 356
357 # we call cpan with -MCPAN::MyConfig in this script, which
358 # is strictly unnecssary as we have to patch CPAN anyway,
359 # so consider it "for good measure".
338 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 360 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
339 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 361 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
340 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 362 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
341 CPAN::Shell->o (conf => q<init>); 363 CPAN::Shell->o (conf => q<init>);
342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 364 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
343 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 365 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
344 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 366 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
345 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 367 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
346 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 368 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
347 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 369 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
348 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 370 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
349 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 371 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
372 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
350 CPAN::Shell->o (conf => q<commit>); 373 CPAN::Shell->o (conf => q<commit>);
351 ' || fatal "error while initialising CPAN" 374 ' || fatal "error while initialising CPAN"
352 375
353 touch "$PERL_PREFIX/staticstamp.install" 376 touch "$PERL_PREFIX/staticstamp.install"
354 fi 377 fi
374installing modules from CPAN 397installing modules from CPAN
375$@ 398$@
376EOF 399EOF
377 400
378 for mod in "$@"; do 401 for mod in "$@"; do
379 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 402 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
380 || fatal "$mod: unable to install from CPAN" 403 || fatal "$mod: unable to install from CPAN"
381 done 404 done
382 rm -rf "$STATICPERL/build" 405 rm -rf "$STATICPERL/build"
383} 406}
384 407
400 rcd $mod 423 rcd $mod
401 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1 424 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
402 "$MAKE" distclean >/dev/null 2>&1 425 "$MAKE" distclean >/dev/null 2>&1
403 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 426 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
404 "$MAKE" || fatal "$mod: error building module" 427 "$MAKE" || fatal "$mod: error building module"
405 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 428 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
406 "$MAKE" distclean >/dev/null 2>&1 429 "$MAKE" distclean >/dev/null 2>&1
407 exit 0 430 exit 0
408 ) || exit $? 431 ) || exit $?
409 done 432 done
410} 433}
442#CAT mkbundle 465#CAT mkbundle
443MKBUNDLE 466MKBUNDLE
444} 467}
445 468
446bundle() { 469bundle() {
470 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
447 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 471 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
448 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 472 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
449 CACHE="$STATICPERL/cache" 473 CACHE="$STATICPERL/cache"
450 mkdir -p "$CACHE" 474 mkdir -p "$CACHE"
451 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 475 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
470 ;; 494 ;;
471 instcpan ) 495 instcpan )
472 ( instcpan "$@" ) || exit 496 ( instcpan "$@" ) || exit
473 exit 497 exit
474 ;; 498 ;;
499 perl )
500 ( install ) || exit
501 exec "$PERL_PREFIX/bin/perl" "$@"
502 exit
503 ;;
475 cpan ) 504 cpan )
476 ( install ) || exit 505 ( install ) || exit
477 "$PERL_PREFIX/bin/cpan" "$@" 506 exec "$PERL_PREFIX/bin/cpan" "$@"
478 exit 507 exit
479 ;; 508 ;;
480 mkbundle ) 509 mkbundle )
481 ( install ) || exit 510 ( install ) || exit
482 bundle "$@" 511 exec bundle "$@"
483 exit 512 exit
484 ;; 513 ;;
485 mkperl ) 514 mkperl )
486 ( install ) || exit 515 ( install ) || exit
487 bundle --perl "$@" 516 exec bundle --perl "$@"
488 exit 517 exit
489 ;; 518 ;;
490 mkapp ) 519 mkapp )
491 ( install ) || exit 520 ( install ) || exit
492 bundle --app "$@" 521 exec bundle --app "$@"
493 exit 522 exit
494 ;; 523 ;;
495 help ) 524 help )
496 podusage 2 525 podusage 2
497 ;; 526 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines